// Pingus - A free Lemmings clone
// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef PINGUSPOTMAP_HH
#define PINGUSPOTMAP_HH

#include <fstream>
#include <string>
#include <vector>
#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>
#include "PinguMap.hh"
#include "ColMap.hh"
#include "plf_datatypes.hh"

struct surface_data {
  CL_Surface* surface;
  int x_pos;
  int y_pos;
  string name;
};

// This map type is the defaulh maptype, it is should be used for the
// most levels. It allows to construct a map, from a set of simple
// small images, this allows the generation of large map without using 
// to much diskspace.
class PinguSpotMap : public PinguMap
{
private:
  vector<surface_data> surfaces;
  int width;
  int height;
public:
  PinguSpotMap();
  PinguSpotMap(ResDescriptor, CL_ResourceManager *);
  virtual ~PinguSpotMap();
  ColMap* PinguSpotMap::get_colmap(void);
  int  load(const char*, CL_ResourceManager*);
  void draw_offset(int of_x, int of_y, double s);
  int  get_height();
  int  get_width();
};

#endif

/* EOF */
